<?php
/*======================================================================*\
|| #################################################################### ||
|| # Youjoomla.com - YJ- Licence Number 98197-WX333345
|| # Licensed to - Hejakal Bekaudar
|| # ---------------------------------------------------------------- # ||
|| # Copyright (C) 2006-2009 Youjoomla.com. All Rights Reserved.        ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/

// no direct access
defined('_JEXEC') or die('Restricted access');
$document = JFactory::getDocument();
require_once (JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_content'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'route.php');
require_once('modules/mod_yn_slider/lib/slike.php');

class modYRNSHelper
{
	static function YRNSgetItems($params)
	{
		global $mainframe;

		$nitems 			= $params->get ('nitems',4);
		$ordering 			= $params->get('ordering',3);// 1 = ordering | 2 = popular | 3 = random 
		$get_items 			= $params->get('get_items',1);
		$getspecific 		= $params->get ('getspecific');
		$chars 				= $params->get ('chars',40);
		$title_chars		= $params->get ('title_chars',45);
		$iscopy         	= $params->get   ('iscopy');
		
		// layout
		$player_width     	= $params->get ('player_width',960);
		$player_title    	= $params->get ('player_title');
		$full_width       	= $player_width + 20;
		
		
		// script
		$itemsVisible 		= $params->get ('itemsVisible',4);
		$autoSlide        	= $params->get ('autoSlide',5000);
		$item_width			= $player_width / $itemsVisible;
		
		/* add styles and scripts */			
		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::base() . 'modules/mod_yn_slider/css/stylesheet.css');
		
		$document->addStyleDeclaration('.ynsnews{width:'.$item_width.'px;}.ynsnews p.text{width:'.($item_width -100).'px;}');
		
		
		$document = JFactory::getDocument();
		$document->addScript(JURI::base() . 'modules/mod_yn_slider/script/yjnslider.js');
		$document->addScriptDeclaration("
			window.addEvents({
				'domready': function(){
					new Showcase({
						overallContainer: 'overall_container".$iscopy ."',
						elementScrolled: 'inner_container".$iscopy ."',
						thumbsContainer: 'YouNews_articles".$iscopy ."',		
						itemsVisible:".$itemsVisible .",
						elemsSlide:1,
						duration:200,
						autoSlide:".$autoSlide.",
						itemsSelector: '.ynsnews',
						itemWidth: ".$item_width.",
						navigationContainer: 'navigation".$iscopy ."',
						navigationElem: 'a'
					});				
				}
			});
		");
		$who = strtolower($_SERVER['HTTP_USER_AGENT']);
		if(preg_match("/msie 6/", $who)) {
			$document->addStyleSheet(JURI::base() . 'modules/mod_yn_slider/css/ifie.php');
		}
		/* prepare database */
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$userId		= (int) $user->get('id');
		$aid		= JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contentConfig = JComponentHelper::getParams( 'com_content' );
		$access		= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$nullDate	= $db->getNullDate();
		$date =       JFactory::getDate();
		if(intval(JVERSION) >= 3 ){	
			$now =         $date->toSql() ; 
		}else{
			$now =         $date->toMySQL(); 
		}
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		// select specific items
		if(!empty($getspecific)){
		$countitems = count($getspecific);
		}
		if(!empty($getspecific) && $countitems > 1 ){
			$specificitems = implode(",", $getspecific);
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}elseif(!empty($getspecific) && $countitems == 1 ){
			$specificitems = $getspecific[0];
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}else{
			$specificitems='';
			$specific_order='NULL';
			$where .= ' AND cc.id = '.$get_items.'';
		}
		/* set items order */
		$ord = array(
			1=>'ordering',
			2=>'hits',
			3=>'RAND()',
			4=>'created ASC',
			5=>'created DESC',
			6=>$specific_order
		);
		$order = $ord[$ordering];
		/* get items */
		$sql = 	'SELECT a.*, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'. 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
				'cc.title as cattitle'.
		
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE '. $where .'' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : '').
				' AND cc.published = 1' .
				' ORDER BY '.$order .' LIMIT 0,'.$nitems.'';
					
		$db->setQuery( $sql );
		$load_items = $db->loadObjectList();

		
		
		$yrns_items =array();
		foreach ( $load_items as $row ) {

			$yrns_item = array(
					'item_intro' 	=> substr(strip_tags($row->introtext),0,$chars),
					'item_link' 		=> htmlspecialchars(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug), ENT_QUOTES, 'UTF-8'),
					'item_img' 		=> $img_url = yrns_image($row),
					'item_title' 	=> substr(strip_tags($row->title),0,$title_chars),
					'item_id'	 	=> htmlspecialchars($row->title, ENT_QUOTES, 'UTF-8'),
					'item_ctitle' 	=> htmlspecialchars($row->cattitle, ENT_QUOTES, 'UTF-8'),
					'img_url'       => '',
					'img_out' 		=>"<a href=\"".htmlspecialchars(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug), ENT_QUOTES, 'UTF-8')."\"><img src=\"".JURI::base().$img_url."\" title=\"".$row->title." \"  alt=\"".$row->title."\"/></a>"
    	);
				$yrns_items[] = $yrns_item;
			}
			return $yrns_items;
	}
}
?>